#! /usr/local/bin/python
# Gnokline version 1.0
# Copyright October 2000 Anders Nordby
#
# THIS SOFTWARE IS PROVIDED BY ANDERS NORDBY ``AS IS'' AND ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
# EVENT SHALL ANDERS NORDBY BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import os, sys, regex, string, StringIO, time
from ConfigParser import *
from string import *

config = ConfigParser()
config.read('gnokline.cfg')
number=config.defaults()['number']
up=config.defaults()['up']
down=config.defaults()['down']
lockfile=config.defaults()['lockfile']
logfile=config.defaults()['logfile']
password=config.defaults()['password']
gnokiips=config.defaults()['gnokiips']
killgnokii=config.defaults()['killgnokii']
gnokiittl=int(config.defaults()['gnokiittl'])
loopwait=int(config.defaults()['loopwait'])

def nukechild():
   os.kill(mypid,9)

def validate(sender, text, smsno):
#   print text[0]
   if len(text) != 3: return 0
   pfix=text[0]
   cmd=text[1]
   pw=text[2]
#   print "---"
#   print text[0]+" "+text[1]+" "+text[2]+" "+sender
#   print password+" "+number
   try:
      log=open(logfile, 'a')
      log.write("-----\n")
      log.write(str(time.ctime(time.time()))+" "+str(time.tzname[0])+"\n")
      log.write("Attempt from: "+sender+"\n")
      log.write("Text: "+text[0]+" "+text[1]+" "+text[2]+"\n")
      log.close
   except IOError:
      print "Could not write log file. Exiting."
      return 0
   
   if pfix != "gnokline":
      print "Wrong prefix: "+pfix+" -- configured prefix is gnokline."
      return 0
   else:
      os.system("gnokii --deletesms ME "+str(smsno)+" "+str(smsno)+" >/dev/null 2>&1")
   if sender != number:
      print "Wrong sender: "+sender+" -- configured number is "+number+"."
      return 0
   if pw != password:
      print "Wrong password: "+pw+" -- configured password is "+password+"."
      return 0
   if cmd == "up":
      os.system(up)
      return 1
   elif cmd == "down":
      os.system(down)
      return 1
   elif cmd == "lock":
      try:
         lck=open(lockfile, 'w')
         lck.close
      except IOError:
         print "Could not write logfile. Exiting."
         return 0
   else:
      print "Unknown command. Exiting."
      return 0

oldpid=os.getpid()
mypid=os.fork()
if mypid == 0:
   hangc=os.popen(gnokiips, 'r').read()
   while mypid == mypid:
      time.sleep(gnokiittl)
      hangcnew=os.popen(gnokiips, 'r').read()
      if hangc == hangcnew: os.system(killgnokii)
      else: hangc = hangcnew
else:
   sys.exitfunc=nukechild
   
i=1
l=13
while l==l:
   try:
      lck=open(lockfile, 'r')
      lck.close
      print "Lockfile exists. Exiting."
      os.system(down)
      sys.exit(0)
   except IOError:
      while i<l:
         try:
            sms=StringIO.StringIO(os.popen("gnokii --getsms ME "+str(i)+" "+str(i)+" 2>&1", "r").read())
         except KeyboardInterrupt:
            sys.exit(0)

         sender=""
         text=""
         line=sms.readline()
         while line:
            if find(line, "Sender: ") != -1: sender=splitfields(line, ' ')[1]
            elif find(line, "Text:") != -1: text=strip(sms.readline())
            line=sms.readline()
         sms.close

         validate(sender,splitfields(text, ' '),i)
         i=i+1
      i=1
      try:
         time.sleep(loopwait)
      except KeyboardInterrupt:
         sys.exit(0)
